#ifndef MAINWINDOW_H
#define MAINWINDOW_H
#include <math.h>
#include "Serial.h"
#include "Light.h"
#include "Sphere.h"
#include "Thor.h"
#include "Ray.h"

 #include <QMainWindow>

 class QAction;
 class QMenu;
 class QVBoxLayout;
 class QHBoxLayout;
 class QLabel;
 class QLayout;

 /**
 @class MainWindow
   QMainWindow.
 ,  ,     ,  ,
 , 27    21 .
 */
 class MainWindow : public QMainWindow
 {
     Q_OBJECT

 public:
     /// 
     MainWindow();
     /// 
     ~MainWindow();


 public slots:
     /// ,       XML.
     void SerializeInXml();
     /// ,       .
     void SerializeInBin();
     /// ,        XML.
     void LoadFromXml();
     /// ,        .
     void LoadFromBin();
     /// ,    .
     void exit();


 public:
     /// ,       .
     void createActions();
     /// ,    .
     void createMenus();
     /// ,    .
     void createStatusBar();
     /// ,       .
     void makeFigures();
     /// ,        .
     void makeLights(); 
     /// ,       .
     void Paint();
     /// ,    .
     void AntiAliasing();

     /// ,    .
     /// @param  Serial  -    Serializer
     /// @return  ,    
     bool Serializing(Serializer *Serial);
     /// ,   .
     /// @param  Temp  -    
     /// @param  koef1   ,      / 
     /// @param  koef2   ,       / 
     /// @param  N     -    
     /// @param  wind  - 
     /// @param  a    ,          
     void wash(QImage *Temp,int koef1, int koef2, int N, double* wind, bool a);

     /// ,      .
     /// @param  temp     ,      
     /// @param  numObj  -    ,        
     /// @param  b1    ,      1 (  )
     /// @param  b2    ,      2 (  )
     /// @param  b3    ,      1 (  )
     /// @param  b4    ,      2 (  )
     /// @param  b5    ,      3 (  )
     /// @return    
     float countMinDist(Vector3D temp, int *numObj, const bool b1, const bool b2, const bool b3, const bool b4, const bool b5);
     /// ,       .
     /// @param  Dist     ,      
     /// @param  Color     ,    
     /// @param  SpeColor     ,     
     /// @param  Light0     ,    ,      
     /// @return     
     Vector3D countLites(Vector3D Dist, Vector3D Color, Vector3D SpeColor, Light Light0);
     /// ,      .
     /// @param  pe  ,     
     void keyPressEvent(QKeyEvent* pe);
     /// ,       .
     /// @param  pe  ,      
     void wheelEvent(QWheelEvent* pe);
     /// ,       .
     /// @param  pe  ,      
     void mousePressEvent(QMouseEvent* pe);
     /// ,     .
     /// @param  pe  ,     
     void mouseMoveEvent(QMouseEvent* pe);
     /// ,       .
     /// @param  pe  ,      
     void mouseReleaseEvent(QMouseEvent * pe);

     ///       
     QWidget *window;
     ///        
     QLabel *labelIm;
     ///          
     QPixmap *image;
     ///      
     QImage *curImage;
     ///       
     Vector3D **RGBCol;
     ///       
     QPoint ptrMousePosition;
     ///       
     Mater Material1;
     ///       
     Mater Material2;
     ///       
     Mater Material3;
     ///       
     Sphere Sphere1;
     ///       
     Sphere Sphere2;
     ///       
     Thor Thor1;
     ///       
     Thor Thor2;
     ///       
     Thor Thor3;
     ///        
     Light Light1;
     ///        
     Light Light2;
     ///      
     Vector3D CamPos;
     ///      
     int Wid;
     ///      
     int Hey;
     ///   -   
     bool AntiAl;

     ///       
     QVBoxLayout *mainLayout;

     ///      
     QMenu *fileMenu;
     ///           
     QAction *XMLLAct;
     ///           
     QAction *BinLAct;
     ///           
     QAction *exitAct;
     ///           
     QAction *XMLSAct;
     ///           
     QAction *BinSAct;
 };

 #endif
